--- l4d2_points_system.sp	2021-08-22 21:08:08.963425800 -0500
+++ l4d2_points_system_menuapi.sp	2021-08-22 20:53:04.517990300 -0500
@@ -22,6 +22,8 @@
 Handle ModulesArray = null;
 Handle Forward1 = null;
 Handle Forward2 = null;
+Handle Forward_BuildBuyMenu = null;
+Handle Forward_BuyMenuSelect = null;
 
 enum plugin_settings{
 	Float:fVersion,
@@ -744,6 +746,8 @@
 	CreateNative("PS_RemovePoints", Native_PS_RemovePoints);
 	Forward1 = CreateGlobalForward("OnPSLoaded", ET_Ignore);
 	Forward2 = CreateGlobalForward("OnPSUnloaded", ET_Ignore);
+	Forward_BuildBuyMenu = CreateGlobalForward("OnBuyMenuBuilding", ET_Ignore, Param_Cell, Param_Cell);
+	Forward_BuyMenuSelect = CreateGlobalForward("OnBuyMenuSelect", ET_Ignore, Param_Cell, Param_Cell, Param_Cell);
 	RegPluginLibrary("ps_natives");
 
 	return;
@@ -1593,25 +1597,33 @@
 {
 	if(GetClientTeam(client) == 2)
 	{
-		decl String:title[40], String:weapons[40], String:upgrades[40], String:health[40];
+		char localizedText[40];
 		new Handle:menu = CreateMenu(TopMenu);
 		if(GetConVarInt(CategoriesEnabled[CategoryWeapons]) == 1)
 		{
-			Format(weapons, sizeof(weapons), "%T", "Weapons", client);
-			AddMenuItem(menu, "g_WeaponsMenu", weapons);
+			Format(localizedText, sizeof(localizedText), "%T", "Weapons", client);
+			AddMenuItem(menu, "g_WeaponsMenu", localizedText);
 		}
 		if(GetConVarInt(CategoriesEnabled[CategoryUpgrades]) == 1)
 		{
-			Format(upgrades, sizeof(upgrades), "%T", "Upgrades", client);
-			AddMenuItem(menu, "g_UpgradesMenu", upgrades);
+			Format(localizedText, sizeof(localizedText), "%T", "Upgrades", client);
+			AddMenuItem(menu, "g_UpgradesMenu", localizedText);
 		}
 		if(GetConVarInt(CategoriesEnabled[CategoryHealth]) == 1)
 		{
-			Format(health, sizeof(health), "%T", "Health", client);
-			AddMenuItem(menu, "g_HealthMenu", health);
+			Format(localizedText, sizeof(localizedText), "%T", "Health", client);
+			AddMenuItem(menu, "g_HealthMenu", localizedText);
 		}
-		Format(title, sizeof(title), "%T", "Points Left", client, PlayerData[client][iPlayerPoints]);
-		SetMenuTitle(menu, title);
+		
+		// Menu extension
+		Action result;	// We dont care about the result
+		Call_StartForward(Forward_BuildBuyMenu);
+		Call_PushCell(client);
+		Call_PushCell(menu);
+		Call_Finish(result);
+		
+		Format(localizedText, sizeof(localizedText), "%T", "Points Left", client, PlayerData[client][iPlayerPoints]);
+		SetMenuTitle(menu, localizedText);
 		DisplayMenu(menu, client, MENU_TIME_FOREVER);
 	}
 	else if(GetClientTeam(client) == 3)
@@ -1763,6 +1775,15 @@
 			{
 				BuildUpgradesMenu(param1);
 			}
+			else {
+				// Menu extension
+				Action result;	// We dont care about the result
+				Call_StartForward(Forward_BuyMenuSelect);
+				Call_PushCell(param1);	// Client ID
+				Call_PushCell(menu);	// The menu handle
+				Call_PushCell(param2);	// Item Index
+				Call_Finish(result);
+			}
 		}
 	}
 }
